// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

struct value {
	int len, ans;
	ll left_val, right_val;
	int left_up_down, left_down, right_up_down, right_down;
	value() {}
	value(ll val) : len(1), ans(1), left_val(val), right_val(val), left_up_down(1), left_down(1), right_up_down(1), right_down(1) {}
};

value comb(value const& v1, value const& v2) {
	value ret;
	ret.len = v1.len + v2.len;

	ret.left_val = v1.left_val;
	ret.right_val = v2.right_val;
	
	ret.ans = max(v1.ans, v2.ans);

	ret.left_down = v1.left_down;
	ret.left_up_down = v1.left_up_down;
	
	ret.right_down = v2.right_down;
	ret.right_up_down = v2.right_up_down;
	
	if (v1.right_val < v2.left_val) {
		ret.ans = max(ret.ans, v1.right_down + v2.left_up_down);
		if (v1.right_down == v1.len) {
			ret.left_up_down = v1.len + v2.left_up_down;
		}

		if (v2.right_down == v2.len) {
			ret.right_down = v2.len + v1.right_down;
		}
		if (v2.right_up_down == v2.len) {
			ret.right_up_down = v2.len + v1.right_down;
		}
	} else if (v1.right_val > v2.left_val) {
		ret.ans = max(ret.ans, v1.right_up_down + v2.left_down);
		if (v1.left_down == v1.len) {
			ret.left_down = v1.len + v2.left_down;
		}
		if (v1.left_up_down == v1.len) {
			ret.left_up_down = v1.len + v2.left_down;
		}

		if (v2.left_down == v2.len) {
			ret.right_up_down = v2.len + v1.right_up_down;
		}
	}

	return ret;
}

void solve() {
	int n;
	cin >> n;
	vector<ll> arr(n);
	for (ll& num : arr) {
		cin >> num;
	}

	int bpv = 1;
	while (bpv < n) {
		bpv *= 2;
	}

	vector<value> segtree(bpv * 2, value(0));
	for (int i = 0; i < n; ++i) {
		segtree[i + bpv] = value(arr[i]);
	}
	for (int i = bpv - 1; i > 0; --i) {
		segtree[i] = comb(segtree[i * 2], segtree[i * 2 + 1]);
	}

	auto segtree_upd = [&](int pos, ll val) {
		pos += bpv;
		segtree[pos] = value(val);
		pos /= 2;
		while (pos) {
			segtree[pos] = comb(segtree[pos * 2], segtree[pos * 2 + 1]);
			pos /= 2;
		}
	};

	auto segtree_get = [&](int l, int r) {
		bool fll = false, flr = false;
		value left, right;
		l += bpv; r += bpv;
		while (l < r) {
			if (l & 1) {
				if (!fll) {
					fll = true;
					left = segtree[l++];
				} else {
					left = comb(left, segtree[l++]);
				}
			}
			if (r & 1) {
				if (!flr) {
					flr = true;
					right = segtree[--r];
				} else {
					right = comb(segtree[--r], right);
				}
			}
			l /= 2; r /= 2;
		}
		if (!fll) {
			return right;
		}
		if (!flr) {
			return left;
		}
		return comb(left, right);
	};

	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int pos;
		ll val;
		cin >> pos >> val;
		--pos;
		segtree_upd(pos, val);

		cout << segtree_get(0, n).ans << "\n";
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}