//
// Created by kgrug on 04.11.2020.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <bitset>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    constexpr int max_m = 200;
    constexpr int max_p = 20;

    int k, m;
    cin >> k >> m;

    map<int, bitset<max_m>> killers_nights;

    int curr_k = k;

    for (int num_night = 0; num_night < m; num_night++) {

        vector<vector<int>> night_graph(k);

        for (int i = 0; i < curr_k; i++) {
            int n, count;
            cin >> n >> count;
            n--;
            for (int j = 0; j < count; j++) {
                int x;
                cin >> x;
                x--;
                night_graph[n].push_back(x);
            }
        }

        int victim;
        cin >> victim;
        victim--;

        for (int killer : night_graph[victim]) {
            if (killers_nights.count(killer) == 0) {
                bitset<max_m> bs;
                killers_nights.insert(make_pair(killer, bs));
            }
            killers_nights[killer][num_night] = true;
        }

        if (killers_nights.count(victim) != 0) {
            killers_nights.erase(victim);
        }

        curr_k--;
    }

    int best_answer = 1000;
    vector<int> best_answer_array;

    unsigned int killers = killers_nights.size();
    unsigned int max_mask = 1u << killers;

    for (unsigned int mask = 0; mask < max_mask; mask++) {
        bitset<max_p> bs_mask(mask);
        bitset<max_m> bs_ans;
        int ans_count = 0;

        int cnt = 0;
        for (auto elem : killers_nights) {
            if (bs_mask[cnt]) {
                bs_ans |= elem.second;
                ans_count++;
            }
            cnt++;
        }

        bool flag = true;
        for (int i = 0; i < m; i++) {
            if (!bs_ans[i]) {
                flag = false;
                break;
            }
        }

        if (flag) {
            if (ans_count < best_answer) {
                best_answer = ans_count;
                best_answer_array.resize(0);

                cnt = 0;
                for (auto elem : killers_nights) {
                    if (bs_mask[cnt]) {
                        best_answer_array.push_back(elem.first + 1);
                    }
                    cnt++;
                }
            }
        }

    }

    cout << best_answer << '\n';
    /*for (int val : best_answer_array) {
        cout << val << " ";
    }*/

    return 0;
}