// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int k, m;
	cin >> k >> m;
	set<int> left;
	for (int i = 0; i < k; ++i) {
		left.insert(i);
	}

	vector<vector<int>> mafia_sets;
	for (int i = 0; i < m; ++i) {
		map<int, vector<int>> cur;
		for (int j = 0; j < szof(left); ++j) {
			int ind, q;
			cin >> ind >> q;
			--ind;
			assert(left.count(ind));
			auto& v = cur[ind];
			for (int x = 0; x < q; ++x) {
				int other;
				cin >> other;
				--other;
				assert(left.count(other));
				v.push_back(other);
			}
		}
		for (auto& p : cur) {
			for (int ind : p.ss) {
				assert(cur.count(ind) && find(cur[ind].begin(), cur[ind].end(), p.ff) != cur[ind].end());
			}
		}
		int died;
		cin >> died;
		--died;
		assert(left.count(died));
		left.erase(died);
		mafia_sets.push_back(cur[died]);
	}

	map<int, int> mafia_ind;
	{
		int cnt = 0;
		for (int ind : left) {
			mafia_ind[ind] = cnt++;
		}
	}
	vector<int> left_order(left.begin(), left.end());

	vector<int> need_masks;

	for (auto& v : mafia_sets) {
		int mask = 0;
		for (int ind : v) {
			if (mafia_ind.count(ind)) {
				mask |= 1 << mafia_ind[ind];
			}
		}
		assert(mask != 0);
		need_masks.push_back(mask);
	}

	int ans = (1 << szof(left)) - 1;

	for (int mask = 0; mask < 1 << szof(left); ++mask) {
		bool ok = true;
		for (int q : need_masks) {
			if (!(q & mask)) {
				ok = false;
				break;
			}
		}

		if (ok) {
			if (__builtin_popcount(ans) > __builtin_popcount(mask)) {
				ans = mask;
			}
		}
	}

	vector<int> outp;
	for (int i = 0; i < szof(left); ++i) {
		if (ans & (1 << i)) {
			outp.push_back(left_order[i]);
		}
	}

	cout << szof(outp) << "\n";
	/*for (int num : outp) {
		cout << num + 1 << " ";
	}
	cout << "\n";*/
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}