// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

const int MAXN = 10000, MAXM = 10;

int main(int argc, char* argv[]) {
	registerValidation(argc, argv);

	int n = inf.readInt(1, MAXN, "n");
	inf.readSpace();
	int m = inf.readInt(1, MAXM, "m");
	inf.readEoln();

	for (int i = 0; i < n; ++i) {
		inf.readInt(1, m, format("c_%d", i + 1));
		if (i < n - 1) {
			inf.readSpace();
		}
	}
	inf.readEoln();

	vector<vector<int>> graph(n);
	for (int i = 0; i < n - 1; ++i) {
		int a = inf.readInt(1, n, format("a_%d", i + 1)) - 1;
		inf.readSpace();
		int b = inf.readInt(1, n, format("b_%d", i + 1)) - 1;
		inf.readEoln();
		graph[a].push_back(b);
		graph[b].push_back(a);
	}

	vector<bool> used(n);

	function<void(int)> dfs  = [&](int v) {
		used[v] = true;
		for (int to : graph[v]) {
			if (!used[to]) {
				dfs(to);
			}
		}
	};

	dfs(0);

	for (int i = 0; i < n; ++i) {
		ensuref(used[i], "graph should be connected");
	}

	inf.readEof();

	return 0;
}