#include <cmath>
#include <functional>
#include <fstream>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <list>
#include <time.h>
#include <math.h>
#include <random>
#include <deque>
#include <queue>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <bitset>
#include <sstream>
#include <chrono>
#include <cstring>

using namespace std;

typedef long long ll;

#ifdef iq
  mt19937 rnd(228);
#else
  mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

const int N = 1e4 + 78;
const int M = 998244353;

int mul(int a, int b) {
  return (a * (ll) b) % M;
}

void add(int &a, int b) {
  a += b;
  if (a >= M) a -= M;
  if (a < 0) a += M;
}

vector <int> g[N];
int par[N];
int dp[N];
int c[N];
vector <int> st;

void dfs(int v, int pr) {
  par[v] = pr;
  for (int x : g[v]) {
    if (x != pr) {
      dfs(x, v);
    }
  }
  st.push_back(v);
}

int main() {
#ifdef iq
  freopen("a.in", "r", stdin);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  int n, m;
  cin >> n >> m;
  for (int i= 0; i < n; i++) {
    cin >> c[i];
    c[i]--;
  }
  for (int i = 1; i < n; i++) {
    int a, b;
    cin >> a >> b;
    a--, b--;
    g[a].push_back(b);
    g[b].push_back(a);
  }
  dfs(0, -1);
  int ans = 0;
  for (int mask = 0; mask < (1 << m); mask++) {
    for (int i = 0; i < n; i++) {
      dp[i] = 1;
    }
    int sum = 0;
    for (int v : st) {
      if ((mask >> c[v]) & 1) {
        dp[v] = 0;
      } else {
        if (par[v] != -1) {
          dp[par[v]] = mul(dp[par[v]], dp[v] + 1);
        }
      }
      add(sum, dp[v]);
    }
    if (__builtin_popcount(mask) % 2 == 0) {
      add(ans, sum);
    } else {
      add(ans, -sum);
    }
  }
  cout << ans << '\n';
}
