// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

const int MOD = 998'244'353;

void add(int& a, int b) {
	a += b;
	if (a >= MOD) {
		a -= MOD;
	}
}

int mult(int a, int b) {
	return (ll) a * b % MOD;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> color(n);
	for (int& num : color) {
		cin >> num;
		--num;
	}

	vector<vector<int>> graph(n);
	for (int i = 0; i < n - 1; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		graph[a].push_back(b);
		graph[b].push_back(a);
	}

	vector<int> used(n);
	int used_cnt = 1;

	function<pii(int, int)> dfs = [&](int v, int mask) {
		used[v] = used_cnt;
		pii ret = {1, 0};
		for (int to : graph[v]) {
			if (used[to] != used_cnt && (mask & (1 << color[to]))) {
				pii tmp = dfs(to, mask);
				ret.ff = mult(ret.ff, tmp.ff);
				add(ret.ss, tmp.ss);
			}
		}
		add(ret.ss, ret.ff);
		add(ret.ff, 1);
		return ret;
	};

	int ans = 0;

	for (int mask = 1; mask < 1 << m; ++mask) {
		++used_cnt;
		int cur = 0;
		for (int i = 0; i < n; ++i) {
			if ((mask & (1 << color[i])) && used[i] != used_cnt) {
				add(cur, dfs(i, mask).ss);
			}
		}

		if ((m - __builtin_popcount(mask)) % 2) {
			add(ans, MOD - cur);
		} else {
			add(ans, cur);
		}
	}

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}