// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

const int MOD = 998'244'353;

void add(int& a, int b) {
	a += b;
	if (a >= MOD) {
		a -= MOD;
	}
}

int sum(int a, int b) {
	add(a, b);
	return a;
}

int mult(int a, int b) {
	return (ll) a * b % MOD;
}

const int MAXN = 10005;
const int MAXM = 10, SZ = 1 << MAXM;

void transform(int *from, int *to) {
	int l = to - from;
	for (int len = 2; len <= l; len *= 2) {
		for (int pos = 0; pos < l; pos += len) {
			for (int i = 0, a = pos, b = pos + len / 2; i < len / 2; i++, a++, b++) {
				add(from[b], from[a]);
			}
		}
	}
} 

void inverse(int *from, int *to) { 
    int l = to - from;
	for (int len = 2; len <= l; len *= 2) {
		for (int pos = 0; pos < l; pos += len) {
			for (int i = 0, a = pos, b = pos + len / 2; i < len / 2; i++, a++, b++) {
				add(from[b], MOD - from[a]);
			}
		}
	}
}

int arra[SZ], arrb[SZ];

void or_conv(int* a, int* b, int* c, int len) {
	copy(a, a + len, arra);
	transform(arra, arra + len);
	copy(b, b + len, arrb);
	transform(arrb, arrb + len);
	for (int i = 0; i < len; ++i) {
		arra[i] = mult(arra[i], arrb[i]);
	}
	inverse(arra, arra + len);
	copy(arra, arra + len, c);
}

int dp[MAXN][SZ];

void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> color(n);
	for (int& num : color) {
		cin >> num;
		--num;
	}

	vector<vector<int>> graph(n);
	for (int i = 0; i < n - 1; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		graph[a].push_back(b);
		graph[b].push_back(a);
	}

	int ans = 0;

	function<void(int, int)> dfs = [&](int v, int p) {
		dp[v][1 << color[v]] = 1;
		for (int to : graph[v]) {
			if (to != p) {
				dfs(to, v);
				or_conv(dp[v], dp[to], dp[v], 1 << m);
			}
		}

		add(dp[v][0], 1);
		add(ans, dp[v][(1 << m) - 1]);
	};

	dfs(0, 0);

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}