// Checker created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

struct point {
	int x, y;
	point(int _x, int _y) : x(_x), y(_y) {}

	point operator+(point const& other) const {
		return point(x + other.x, y + other.y);
	}

	point operator-(point const& other) const {
		return point(x - other.x, y - other.y);
	}

	bool operator<(point const& other) const {
		return x < other.x || (x == other.x && y < other.y);
	}

	bool operator>(point const& other) const {
		return other.operator<(*this);
	}

	bool operator<=(point const& other) const {
		return !operator>(other);
	}
};

ll cross(point const& p1, point const& p2) {
	return (ll) p1.x * p2.y - (ll) p1.y * p2.x;
}

ll dot(point const& p1, point const& p2) {
	return (ll) p1.x * p2.x + (ll) p1.y * p2.y;
}

bool check_conseq(point const& a, point const& b, point const& c) {
	if (cross(a - b, c - b) == 0 && dot(a - b, c - b) >= 0) {
		return false;
	}
	return true;
}

int sign(ll num) {
	return num > 0 ? 1 : (num < 0 ? -1 : 0);
}

bool intersecting(point const& a, point const& b, point const& c, point const& d) {
	if (cross(b - a, c - a) == 0 && cross(b - a, d - a) == 0) {
		return max(min(a, b), min(c, d)) <= min(max(a, b), max(c, d));
	}

	return sign(cross(c - a, b - a)) * sign(cross(b - a, d - a)) >= 0 && 
		sign(cross(a - c, d - c)) * sign(cross(d - c, b - c)) >= 0;
}

int main(int argc, char* argv[]) {
	setName("compare two outputs");
	registerTestlibCmd(argc, argv);

	int n = inf.readInt();
	vector<point> points;
	for (int i = 0; i < n; ++i) {
		int x = inf.readInt();
		int y = inf.readInt();
		points.push_back(point(x, y));
	}

	auto check_outp = [&](auto& stream) {
		string outcome = stream.readLine("Yes|No");
		if (outcome == "No") {
			return 0ll;
		}

		vector<int> order;
		for (int i = 0; i < n; ++i) {
			order.push_back(stream.readInt(1, n) - 1);
		}

		{
			set<int> tmp(order.begin(), order.end());
			stream.ensuref(szof(tmp) == n, "not a permutation");
		}

		for (int i = 0; i < n; ++i) {
			for (int j = i + 1; j < n; ++j) {
				if ((i + 1) % n == j) {
					stream.ensuref(check_conseq(points[order[i]], points[order[j]], points[order[(j + 1) % n]]), "consecutive points %d, %d and %d are bad", 
						order[i] + 1, order[j] + 1, order[(j + 1) % n] + 1);
				} else if ((j + 1) % n == i) {
					stream.ensuref(check_conseq(points[order[j]], points[order[i]], points[order[(i + 1) % n]]), "consecutive points %d, %d and %d are bad",
						order[j] + 1, order[i] + 1, order[(i + 1) % n] + 1);
				} else {
					stream.ensuref(!intersecting(points[order[i]], points[order[(i + 1) % n]], points[order[j]], points[order[(j + 1) % n]]),
						"sides (%d, %d) and (%d, %d) are intersecting", 
						order[i] + 1, order[(i + 1) % n] + 1, order[j] + 1, order[(j + 1) % n] + 1);
				}
			}
		}

		ll sq = 0;
		for (int i = 0; i < n; ++i) {
			sq += cross(points[order[i]], points[order[(i + 1) % n]]);
		}

		return abs(sq);
	};

	ll jans = check_outp(ans);
	ll pans = check_outp(ouf);

	if (jans > pans) {
		quitf(_wa, "jury found better polygon, area %lld instead of %lld", jans, pans);
	}

	if (pans > jans) {
		quitf(_fail, "participant found better polygon, area %lld instead of %lld", pans, jans);
	}

	quitf(_ok, "best polygon has area %lld / 2", pans);


	return 0;
}