#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include "testlib.h"
//#include <ext/pb_ds/assoc_container.hpp>
#define fi first
#define se second
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
#ifndef LOCAL
#  define cerr __get_ce
#endif
 
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

const int MAXX = (int)1e8;

struct point {
	ll x, y;
	point (ll x_ = 0, ll y_ = 0): x(x_), y(y_) {};
	point operator - (point const a) {
		return point(x - a.x, y - a.y);
	}
	ll operator * (point const a) {
		return x * a.y - y * a.x;
	}
	ll operator / (point const a) {
		return x * a.x + y * a.y;
	}
	bool operator == (point const a) const {
		return x == a.x && y == a.y;
	}
	bool operator <(const point a) const {
		if (x != a.x)
			return x < a.x;
		return y < a.y;
	}
	ll len() {
		return x * x + y * y;
	}
};

ll sign(ll a) {
	if (a > 0)
		return 1;
	else if (a < 0)
		return -1;
	else
		return 0;
}

bool inter(point a, point b, point c, point d) {
	if (a == c || a == d || b == c || b == d) {
		return 0;
	}
	//*
	if ((c - a) * (b - a) == 0 && (a - c) / (b - c) < 0)
		return 1;
	if ((d - a) * (b - a) == 0 && (a - d) / (b - d) < 0)
		return 1;
	if ((a - c) * (d - c) == 0 && (c - a) / (d - a) < 0)
		return 1;
	if ((b - c) * (d - c) == 0 && (c - b) / (d - b) < 0)
		return 1;
	//*/
	return (sign((c - a) * (b - a)) * sign((d - a) * (b - a)) <= 0 && sign((a - c) * (d - c)) * sign((b - c) * (d - c)) <= 0);
}

point st;

bool cmp(point a, point b) {
	a = a - st;
	b = b - st;
	if (a * b != 0)
		return a * b > 0;
	return a.len() < b.len();
}

vector<point> build(set<point> se) {
	vector<point> mas, ans;
	for (auto p: se)
		mas.push_back(p);
	st = mas[0];
	sort(mas.begin(), mas.end(), cmp);
	for (int i = 0; i < (int)mas.size(); i++) {
		int j = ans.size();
		while (j > 1 && (ans[j - 1] - ans[j - 2]) * (mas[i] - ans[j - 1]) <= 0) {
			j--;
			ans.pop_back();
		}
		ans.push_back(mas[i]);
	}
	return ans;
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    /* Read number from command line. */
    int n = atoi(argv[1]);
    int m = atoi(argv[2]);
    set<point> se;
    vector<point> conv;
    while (true) {
    	int x = rnd.next(-MAXX, MAXX);
    	int y = rnd.next(-MAXX, MAXX);
    	se.insert(point(x, y));
    	conv = build(se);
    	if ((int)conv.size() == n)
    		break;
    }
    se.clear();
    for (auto p: conv)
    	se.insert(p);
    int mnx = MAXX, mny = MAXX, mxx = -MAXX, mxy = -MAXX;
    for (auto p: conv) {
    	mnx = min(mnx, (int)p.x);
    	mxx = max(mxx, (int)p.x);
    	mny = min(mny, (int)p.y);
    	mxy = max(mxy, (int)p.y);
    }
    	
    while ((int)se.size() < n + m) {
    	int x = rnd.next(mnx, mxx);
    	int y = rnd.next(mny, mxy);
    	point p(x, y);
    	se.insert(p);
    	if (conv != build(se)) {
    		se.erase(p);
    	}
    }	
    vector<point> mas;
    for (auto p: se)
    	mas.push_back(p);
    shuffle(mas.begin(), mas.end());
    cout << n + m << "\n";
    for (auto p: mas)
    	cout << p.x << " " << p.y << "\n";
    return 0;    
}