// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

struct point {
	int x, y;
	point(int _x, int _y) : x(_x), y(_y) {}

	point operator+(point const& other) const {
		return point(x + other.x, y + other.y);
	}

	point operator-(point const& other) const {
		return point(x - other.x, y - other.y);
	}

	bool operator<(point const& other) const {
		return x < other.x || (x == other.x && y < other.y);
	}

	bool operator>(point const& other) const {
		return other.operator<(*this);
	}

	bool operator<=(point const& other) const {
		return !operator>(other);
	}
};

ll cross(point const& p1, point const& p2) {
	return (ll) p1.x * p2.y - (ll) p1.y * p2.x;
}

ll dot(point const& p1, point const& p2) {
	return (ll) p1.x * p2.x + (ll) p1.y * p2.y;
}

bool check_conseq(point const& a, point const& b, point const& c) {
	if (cross(a - b, c - b) == 0 && dot(a - b, c - b) >= 0) {
		return false;
	}
	return true;
}

int sign(ll num) {
	return num > 0 ? 1 : (num < 0 ? -1 : 0);
}

bool intersecting(point const& a, point const& b, point const& c, point const& d) {
	if (cross(b - a, c - a) == 0 && cross(b - a, d - a) == 0) {
		return max(min(a, b), min(c, d)) <= min(max(a, b), max(c, d));
	}

	return sign(cross(c - a, b - a)) * sign(cross(b - a, d - a)) >= 0 && 
		sign(cross(a - c, d - c)) * sign(cross(d - c, b - c)) >= 0;
}

void solve() {
	int n;
	cin >> n;
	vector<point> points;
	for (int i = 0; i < n; ++i) {
		int x, y;
		cin >> x >> y;
		points.push_back({x, y});
	}

	vector<int> order(n);
	iota(order.begin(), order.end(), 0);

	ll best_ans = 0;
	vector<int> order_ans;

	do {
		bool ok = true;
		for (int i = 0; i < n; ++i) {
			for (int j = i + 1; j < n; ++j) {
				if ((i + 1) % n == j) {
					if (!check_conseq(points[order[i]], points[order[j]], points[order[(j + 1) % n]])) {
						ok = false;
						break;
					}
				} else if ((j + 1) % n == i) {
					if (!check_conseq(points[order[j]], points[order[i]], points[order[(i + 1) % n]])) {
						ok = false;
						break;
					}
				} else {
					if (intersecting(points[order[i]], points[order[(i + 1) % n]], points[order[j]], points[order[(j + 1) % n]])) {
						ok = false;
						break;
					}
				}
			}
			if (!ok) {
				break;
			}
		}
		if (ok) {
			ll cur_s = 0;
			for (int i = 0; i < n; ++i) {
				cur_s += cross(points[order[i]], points[order[(i + 1) % n]]);
			}
			cur_s = abs(cur_s);
			if (best_ans < cur_s) {
				best_ans = cur_s;
				order_ans = order;
			}
		}
	} while (next_permutation(order.begin() + 1, order.end()));

	if (best_ans == 0) {
		cout << "No\n";
	} else {
		cout << "Yes\n";
		for (int num : order_ans) {
			cout << num + 1 << " ";
		}
		cout << "\n";
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}