#include <iostream>
#include <vector>

using namespace std;

vector<unsigned int> move_north(vector<unsigned int> const &x) {
    return vector<unsigned int>{x[1], x[5], x[2], x[3], x[0], x[4]};
}

vector<unsigned int> move_south(vector<unsigned int> const &x) {
    return vector<unsigned int>{x[4], x[0], x[2], x[3], x[5], x[1]};
}

vector<unsigned int> move_west(vector<unsigned int> const &x) {
    return vector<unsigned int>{x[2], x[1], x[5], x[0], x[4], x[3]};
}

vector<unsigned int> move_east(vector<unsigned int> const &x) {
    return vector<unsigned int>{x[3], x[1], x[0], x[5], x[4], x[2]};
}

int main() {

    vector<unsigned int> x(6);
    for (unsigned int i = 0; i < 6; i++) {
        cin >> x[i];
    }
    vector<unsigned int> pos(6);
    for (unsigned int i = 0; i < 6; i++) {
        pos[i] = i;
    }
    unsigned int t;
    cin >> t;

    unsigned long long s = 0;
    unsigned int d = 0;
    vector<vector<vector<int>>> steps(
            6,
            vector<vector<int>>(6, vector<int>(4, -1))
    );

    vector<unsigned int> sums{0};
    unsigned int cnt = 0;
    while (steps[pos[0]][pos[1]][d] == -1) {
        steps[pos[0]][pos[1]][d] = cnt++;
        s += x[pos[5]];
        sums.push_back(s);
        d = (d + x[pos[5]]) % 4;
        if (d == 0) {
            pos = move_north(pos);
        } else if (d == 1) {
            pos = move_east(pos);
        } else if (d == 2) {
            pos = move_south(pos);
        } else {
            pos = move_west(pos);
        }
    }

    unsigned int st = steps[pos[0]][pos[1]][d];
    unsigned long long cycle = sums.back() - sums[st];
    vector<unsigned int> mods;
    for (unsigned int i = st; i < sums.size(); i++) {
        mods.push_back(sums[i] % cycle);
    }

    for (unsigned int i = 0; i < t; i++) {
        unsigned long long q;
        cin >> q;
        bool flag = false;
        if (q >= sums[st]) {
            for (unsigned long long mod : mods) {
                if (q % cycle == mod) {
                    flag = true;
                    break;;
                }
            }
        } else {
            for (unsigned int j = 0; j < st; j++) {
                if (q == sums[j]) {
                    flag = true;
                    break;
                }
            }
        }
        if (flag) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }

}