// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

vector<vector<int>> around = {
	{1, 3, 4, 2},
	{5, 3, 0, 2},
	{5, 1, 0, 4},
	{5, 4, 0, 1},
	{0, 3, 5, 2},
	{1, 2, 4, 3}
};

void solve() {
	int cur_down = 0;
	int cur_rot = 0;
	int cur_dir = 0;

	vector<int> vals;
	for (int i = 0; i < 6; ++i) {
		int num;
		cin >> num;
		vals.push_back(num);
	}

	map<tuple<int, int, int>, int> mem;

	int pref = -1, cycle = -1;
	int s = 0;

	while (true) {
		tuple<int, int, int> cur = {cur_down, cur_rot, cur_dir};
		if (mem.count(cur)) {
			pref = mem[cur];
			cycle = s - pref;
			break;
		}

		mem[cur] = s;

		int x = vals[5 - cur_down];
		s += x;
		cur_dir = (cur_dir + x) % 4;

		int new_down = around[cur_down][(cur_rot + cur_dir) % 4];
		int new_rot = (find(around[new_down].begin(), around[new_down].end(), cur_down) - around[new_down].begin() - (cur_dir + 2) + 100) % 4;

		cur_down = new_down;
		cur_rot = new_rot;
	}

	vector<bool> pref_have(pref);
	vector<bool> cycle_have(cycle);
	for (auto p : mem) {
		if (p.ss < pref) {
			pref_have[p.ss] = true;
		} else {
			cycle_have[p.ss - pref] = true;
		}
	}

	int t;
	cin >> t;
	for (int i = 0; i < t; ++i) {
		ll q;
		cin >> q;
		if (q < pref) {
			if (pref_have[q]) {
				cout << "Yes\n";
			} else {
				cout << "No\n";
			}
		} else {
			if (cycle_have[(q - pref) % cycle]) {
				cout << "Yes\n";
			} else {
				cout << "No\n";
			}
		}
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}